package jsfasync;

import java.util.ArrayList;
import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ApplicationScoped;

@ManagedBean
@ApplicationScoped
public class JsfAsync 
{
    private final List<String> messages;
    private final Object wakeup;
    
    public JsfAsync() 
    {
        wakeup = new Object();
        messages = new ArrayList<String>(); 
    }
        
    public void setNewMessage(String msg)
    {
        synchronized(messages)
        {
            messages.add(msg);
        }            
    }
        
    public void say()
    {  
        synchronized(wakeup)
        {
            wakeup.notifyAll();
        }
    }
    
    public void resend()
    {         
        try { 
               synchronized(wakeup)
               {
                  wakeup.wait(30000);
                }
        } catch (Exception e) { }    
    }
    
    public void clear()
    {
        synchronized(messages)
        {
            messages.clear();
        }
        say();
    }
      
    public String getNewMessage()
    {
        return "";
    }
    
    public String getMsgs()
    {
        StringBuilder msgs = new StringBuilder();
        synchronized(messages)
        {
            for (String m : messages)
            {
                msgs.append(m);
                msgs.append("<br />");
            }        
            return msgs.toString();
        }
    }
        
}
